import type * as c4 from '@likec4/core';
import { type ParsedAstElement, type ParsedAstRelation, ast } from '../../ast';
import { type Base } from './Base';
export type WithModel = ReturnType<typeof ModelParser>;
export declare function ModelParser<TBase extends Base>(B: TBase): {
    new (...args: any[]): {
        parseModel(): void;
        parseElement(astNode: ast.Element): ParsedAstElement;
        parseRelation(astNode: ast.Relation): ParsedAstRelation;
        isValid: import("../../validation").IsValidFn;
        readonly services: import("../..").LikeC4Services;
        readonly doc: import("../../ast").ParsedLikeC4LangiumDocument;
        resolveFqn(node: ast.FqnReferenceable): c4.Fqn;
        getAstNodePath(node: c4): any;
        getMetadata(metadataAstNode: ast.MetadataProperty | undefined): {
            [key: string]: string;
        } | undefined;
        convertTags<E extends {
            tags?: ast.Tags;
        }>(withTags?: E | undefined): any;
        parseTags<E extends {
            tags?: ast.Tags;
        }>(withTags?: E): c4.NonEmptyArray<c4.Tag> | null;
        convertLinks(source?: ast.LinkProperty["$container"]): import("../../ast").ParsedLink[] | undefined;
        parseLinks(source?: ast.LinkProperty["$container"]): import("../../ast").ParsedLink[] | undefined;
    };
} & TBase;
